import java.util.*;
public class PFSearch {
    Node[] nodes;
    public PFSearch(Node[] nodes) {
	this.nodes = nodes;
    }
    public void solve(Node src,Node dst) {
	// 未確定のノードを優先度キューで管理する
	PriorityQueue<Node> q = new PriorityQueue<Node>();
	// まず、全てのノードを未確定のノードとする。
	for (int i=0; i<nodes.length; i++) {
	    nodes[i].value = Double.MAX_VALUE;	// 距離の初期値は無限大
	    q.add(nodes[i]);
	}

	// [課題] ここに適切なコードを追加しなさい 。
	//   始点ノードの距離を0と設定する。
	//     未確定ノード群から始点ノードを一旦取り除き
	//     距離を0に書き換えて
	//     未確定ノード群に戻す

	while (q.size() > 0) {	// 未確定ノード群にノードがある限り繰り返す

	// [課題] ここに適切なコードを追加しなさい 。
	//   距離最小ノードを未確定ノード群から取り出す(Node x に)。

	    if (x.value == Double.MAX_VALUE) return; // 非連結ノード
	    if (x == dst) return; // 目的地までの距離が確定したら終了する
	    // 取り出したノードに隣接するノードの距離を書き換える
	    for (Edge e: x.edges) {// xにつながっている各エッジに対して
		Node y = e.dst; // xに隣接しているノードをyとする
		double newValue = x.value +e.value; // x経由でのyまでの距離
		if (newValue < y.value) { // 新しい経路の方が近ければ

		    // [課題] ここに適切なコードを追加しなさい 。
		    // yが未確定ノード群に属していれば
		    //   yを未確定ノード群から取り除き
		    //   yの距離を変更してから
		    //   yのNode内に「x経由」と記録して
		    //   yを未確定ノード群に戻す

		}
	    }
	}
    }
    public Node[] getPath(int id) {
	ArrayList<Node> v = new ArrayList<Node>();
	for (Node node = nodes[id]; node != null; node=node.via) v.add(node);
	for (int i=0; i<v.size()/2; i++) { // 逆順なので順番を逆に戻す
	    int j=v.size()-1-i;
	    Node tmp=v.get(i);
	    v.set(i,v.get(j));
	    v.set(j,tmp);
	}
	return v.toArray(new Node[0]); // 配列に変換して返す
    }
    public String toString() {
	return Node.toString(nodes);
    }
}
